'use strict';

var _chai = require('chai');

var _Subject = require('rxjs/Subject');

var _filter = require('rxjs/operators/filter');

var _map = require('rxjs/operators/map');

var _combineEpics = require('./combineEpics');

var _combineEpics2 = _interopRequireDefault(_combineEpics);

var _ActionsObservable = require('./ActionsObservable');

var _ActionsObservable2 = _interopRequireDefault(_ActionsObservable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/no-extraneous-dependencies, func-names */
/* global describe, it */
describe('frint-store › combineEpics', function () {
  it('triggers epics correct response', function () {
    var pingEpic = function pingEpic(action$) {
      return action$.pipe((0, _filter.filter)(function (action) {
        return action.type === 'PING';
      }), (0, _map.map)(function () {
        return { type: 'PONG' };
      }));
    };

    var rootEpic = (0, _combineEpics2.default)(pingEpic);

    var subject$ = new _Subject.Subject();
    var actions$ = new _ActionsObservable2.default(subject$);
    var result$ = rootEpic(actions$);
    var emittedActions = [];

    var subscription = result$.subscribe(function (emittedAction) {
      emittedActions.push(emittedAction);
    });
    subject$.next({ type: 'PING' });

    (0, _chai.expect)(emittedActions).to.deep.equal([{ type: 'PONG' }]);

    subscription.unsubscribe();
  });
});